/**
 * Copyright (C) 2015 - 2018 Kosmos contact@kosmos.fr
 *
 * Projet: blog
 * Version: 1.07.00-BETA-01
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.kosmos.blog.sgbd;

import com.jsbsoft.jtf.database.OMContext;
import com.kosmos.blog.bean.BlogBean;
import com.kosmos.datasource.sql.utils.SqlDateConverter;
import org.apache.commons.lang3.StringUtils;

import java.sql.*;

/**
 * Classe d'acces aux donnees pour blog.
 */
@Deprecated
public class BlogDB extends BlogBean {

    /**
     *
     */
    private static final long serialVersionUID = 4708226873757607075L;

    protected OMContext ctx = null;

    protected String qualifier = null;

    private ResultSet rs = null;

    @Override
    public String toString() {
        return toString(".");
    }

    public String toString(final String aSeparator) {
        return String.format("%d%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%d%s%s%s%s%s%s", getId(), aSeparator, getTitre(), aSeparator, getDescription(), aSeparator, getThematique(), aSeparator, getArchivage(), aSeparator, getCode(), aSeparator, getCodeRubrique(), aSeparator, getCodeRattachement(), aSeparator, getMetaKeywords(), aSeparator, getMetaDescription(), aSeparator, getTitreEncadre(), aSeparator, getContenuEncadre(), aSeparator, getEncadreRecherche(), aSeparator, getEncadreRechercheBis(), aSeparator, getDateAlerte(), aSeparator, getMessageAlerte(), aSeparator, getDateCreation(), aSeparator, getDateProposition(), aSeparator, getDateValidation(), aSeparator, getDateModification(), aSeparator, getCodeRedacteur(), aSeparator, getCodeValidation(), aSeparator, getLangue(), aSeparator, getEtatObjet(), aSeparator, getNbHits(), aSeparator, getDiffusionPublicVise(), aSeparator, getDiffusionModeRestriction(), aSeparator, getDiffusionPublicViseRestriction());
    }

    public void setCtx(final OMContext _ctx) {
        ctx = _ctx;
    }

    public void setQualifier(final String qualifier) {
        this.qualifier = qualifier;
    }

    private Connection getConnection() {
        return ctx.getConnection();
    }

    public void add() throws Exception {
        PreparedStatement stmt = null;
        ResultSet rs = null;
        try {
            stmt = getConnection().prepareStatement("insert into BLOG (ID_BLOG , TITRE , DESCRIPTION , THEMATIQUE , ARCHIVAGE , CODE , CODE_RUBRIQUE , CODE_RATTACHEMENT , META_KEYWORDS , META_DESCRIPTION , TITRE_ENCADRE , CONTENU_ENCADRE , ENCADRE_RECHERCHE , ENCADRE_RECHERCHE_BIS , DATE_ALERTE , MESSAGE_ALERTE , DATE_CREATION , DATE_PROPOSITION , DATE_VALIDATION , DATE_MODIFICATION , CODE_REDACTEUR , CODE_VALIDATION , LANGUE , ETAT_OBJET , NB_HITS , DIFFUSION_PUBLIC_VISE , DIFFUSION_MODE_RESTRICTION , DIFFUSION_PUBLIC_VISE_RESTRICTION) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", PreparedStatement.RETURN_GENERATED_KEYS);
            stmt.setObject(1, getId(), Types.BIGINT);
            stmt.setObject(2, getTitre(), Types.VARCHAR);
            stmt.setObject(3, getDescription(), Types.LONGVARCHAR);
            stmt.setObject(4, getThematique(), Types.LONGVARCHAR);
            stmt.setObject(5, getArchivage(), Types.VARCHAR);
            stmt.setObject(6, getCode(), Types.VARCHAR);
            stmt.setObject(7, getCodeRubrique(), Types.VARCHAR);
            stmt.setObject(8, getCodeRattachement(), Types.VARCHAR);
            stmt.setObject(9, getMetaKeywords(), Types.LONGVARCHAR);
            stmt.setObject(10, getMetaDescription(), Types.LONGVARCHAR);
            stmt.setObject(11, getTitreEncadre(), Types.VARCHAR);
            stmt.setObject(12, getContenuEncadre(), Types.LONGVARCHAR);
            stmt.setObject(13, getEncadreRecherche(), Types.VARCHAR);
            stmt.setObject(14, getEncadreRechercheBis(), Types.VARCHAR);
            stmt.setObject(15, SqlDateConverter.toDate(getDateAlerte()), Types.DATE);
            stmt.setObject(16, getMessageAlerte(), Types.LONGVARCHAR);
            stmt.setObject(17, SqlDateConverter.toTimestamp(getDateCreation()), Types.TIMESTAMP);
            stmt.setObject(18, SqlDateConverter.toTimestamp(getDateProposition()), Types.TIMESTAMP);
            stmt.setObject(19, SqlDateConverter.toTimestamp(getDateValidation()), Types.TIMESTAMP);
            stmt.setObject(20, SqlDateConverter.toTimestamp(getDateModification()), Types.TIMESTAMP);
            stmt.setObject(21, getCodeRedacteur(), Types.VARCHAR);
            stmt.setObject(22, getCodeValidation(), Types.VARCHAR);
            stmt.setObject(23, getLangue(), Types.VARCHAR);
            stmt.setObject(24, getEtatObjet(), Types.VARCHAR);
            stmt.setObject(25, getNbHits(), Types.BIGINT);
            stmt.setObject(26, getDiffusionPublicVise(), Types.LONGVARCHAR);
            stmt.setObject(27, getDiffusionModeRestriction(), Types.VARCHAR);
            stmt.setObject(28, getDiffusionPublicViseRestriction(), Types.LONGVARCHAR);
            final int rowsAffected = stmt.executeUpdate();
            if (rowsAffected == 0) {
                throw new Exception("METHOD_AFFCTD_NOROWS");
            } else if (rowsAffected > 1) {
                throw new Exception("METHOD_AFFCTD_MULTROWS");
            }
            rs = stmt.getGeneratedKeys();
            rs.next();
            setId(rs.getLong(1));
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD add()", e);
        } finally {
            if (rs != null) {
                rs.close();
            }
            if (stmt != null) {
                stmt.close();
            }
        }
    }

    public void delete() throws Exception {
        PreparedStatement stmt = null;
        try {
            stmt = getConnection().prepareStatement("delete from BLOG where ID_BLOG = ?");
            stmt.setObject(1, getId(), Types.BIGINT);
            final int rowsAffected = stmt.executeUpdate();
            if (rowsAffected == 0) {
                throw new Exception("METHOD_AFFCTD_NOROWS");
            } else if (rowsAffected > 1) {
                throw new Exception("METHOD_AFFCTD_MULTROWS");
            }
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD delete()", e);
        } finally {
            if (stmt != null) {
                stmt.close();
            }
        }
    }

    public String getSQLBaseQuery() {
        return String.format("select distinct T1.ID_BLOG, T1.TITRE, T1.DESCRIPTION, T1.THEMATIQUE, T1.ARCHIVAGE, T1.CODE, T1.CODE_RUBRIQUE, T1.CODE_RATTACHEMENT, T1.META_KEYWORDS, T1.META_DESCRIPTION, T1.TITRE_ENCADRE, T1.CONTENU_ENCADRE, T1.ENCADRE_RECHERCHE, T1.ENCADRE_RECHERCHE_BIS, T1.DATE_ALERTE, T1.MESSAGE_ALERTE, T1.DATE_CREATION, T1.DATE_PROPOSITION, T1.DATE_VALIDATION, T1.DATE_MODIFICATION, T1.CODE_REDACTEUR, T1.CODE_VALIDATION, T1.LANGUE, T1.ETAT_OBJET, T1.NB_HITS, T1.DIFFUSION_PUBLIC_VISE, T1.DIFFUSION_MODE_RESTRICTION, T1.DIFFUSION_PUBLIC_VISE_RESTRICTION from %sBLOG T1 ", qualifier == null ? StringUtils.EMPTY : qualifier);
    }

    public String getSQLBaseOptimizedQuery() {
        return String.format("select T1.ID_BLOG, T1.CODE, T1.LANGUE from %sBLOG T1 ", qualifier == null ? StringUtils.EMPTY : qualifier);
    }

    /**
     * Renvoie l'element suivant du ResultSet.
     */
    public boolean nextItem() throws Exception {
        boolean res = false;
        try {
            if (rs.next()) {
                if (ctx.getDatas().get("optimizedSelect") != null) {
                    retrieveFromOptimizedRS();
                } else {
                    retrieveFromRS();
                }
                res = true;
            } else {
                try {
                    rs.close();
                } finally {
                    rs = null;
                }
            }
        } catch (final Exception e) {
            throw new Exception("ERROR_IN_METHOD nextItem()", e);
        }
        return res;
    }

    /**
     * Recuperation d'une ligne de la base de donnees.
     */
    public void retrieve() throws Exception {
        PreparedStatement stmt = null;
        try {
            stmt = getConnection().prepareStatement("select T1.ID_BLOG, T1.TITRE, T1.DESCRIPTION, T1.THEMATIQUE, T1.ARCHIVAGE, T1.CODE, T1.CODE_RUBRIQUE, T1.CODE_RATTACHEMENT, T1.META_KEYWORDS, T1.META_DESCRIPTION, T1.TITRE_ENCADRE, T1.CONTENU_ENCADRE, T1.ENCADRE_RECHERCHE, T1.ENCADRE_RECHERCHE_BIS, T1.DATE_ALERTE, T1.MESSAGE_ALERTE, T1.DATE_CREATION, T1.DATE_PROPOSITION, T1.DATE_VALIDATION, T1.DATE_MODIFICATION, T1.CODE_REDACTEUR, T1.CODE_VALIDATION, T1.LANGUE, T1.ETAT_OBJET, T1.NB_HITS, T1.DIFFUSION_PUBLIC_VISE, T1.DIFFUSION_MODE_RESTRICTION, T1.DIFFUSION_PUBLIC_VISE_RESTRICTION from BLOG T1 where T1.ID_BLOG = ?");
            stmt.setObject(1, getId(), Types.BIGINT);
            rs = stmt.executeQuery();
            if (!rs.next()) {
                throw new Exception("retrieve : METHOD_NO_RESULTS");
            }
            retrieveFromRS();
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD retrieve()", e);
        } finally {
            if (rs != null) {
                rs.close();
            }
            if (stmt != null) {
                stmt.close();
            }
        }
    }

    private void retrieveFromRS() throws Exception {
        try {
            setId(rs.getLong(1));
            setTitre(rs.getString(2));
            setDescription(rs.getString(3));
            setThematique(rs.getString(4));
            setArchivage(rs.getString(5));
            setCode(rs.getString(6));
            setCodeRubrique(rs.getString(7));
            setCodeRattachement(rs.getString(8));
            setMetaKeywords(rs.getString(9));
            setMetaDescription(rs.getString(10));
            setTitreEncadre(rs.getString(11));
            setContenuEncadre(rs.getString(12));
            setEncadreRecherche(rs.getString(13));
            setEncadreRechercheBis(rs.getString(14));
            setDateAlerte(SqlDateConverter.fromDate(rs.getDate(15)));
            setMessageAlerte(rs.getString(16));
            setDateCreation(SqlDateConverter.fromTimestamp(rs.getTimestamp(17)));
            setDateProposition(SqlDateConverter.fromTimestamp(rs.getTimestamp(18)));
            setDateValidation(SqlDateConverter.fromTimestamp(rs.getTimestamp(19)));
            setDateModification(SqlDateConverter.fromTimestamp(rs.getTimestamp(20)));
            setCodeRedacteur(rs.getString(21));
            setCodeValidation(rs.getString(22));
            setLangue(rs.getString(23));
            setEtatObjet(rs.getString(24));
            setNbHits(rs.getLong(25));
            setDiffusionPublicVise(rs.getString(26));
            setDiffusionModeRestriction(rs.getString(27));
            setDiffusionPublicViseRestriction(rs.getString(28));
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD retrieveFromRS()", e);
        }
    }

    private void retrieveFromOptimizedRS() throws Exception {
        try {
            // get output from result set
            setId(rs.getLong(1));
            setCode(rs.getString(2));
            setLangue(rs.getString(3));
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD retrieveFromOptimizedRS()", e);
        }
    }

    /**
     * Cette methode optimise l'execution de la requete (pas de count)
     *
     * @param sqlSuffix
     * @throws Exception
     */
    public void selectNoCount(final String sqlSuffix) throws Exception {
        PreparedStatement stmt;
        try {
            String query = getSQLBaseQuery();
            if (sqlSuffix != null) {
                query += sqlSuffix;
            }
            stmt = getConnection().prepareStatement(query);
            rs = stmt.executeQuery();
        } catch (final SQLException e) {
            throw new Exception("SELECT_FAILED", e);
        }
    }

    public int select(final String sqlSuffix) throws Exception {
        int count;
        if (ctx.getDatas().get("optimizedObject") != null && ctx.getDatas().get("optimizedSelect") != null) {
            count = selectNoCountOptimized(sqlSuffix);
        } else {
            PreparedStatement stmt;
            try {
                // recuperation nombre de lignes
                String query = String.format("select count(distinct T1.ID_BLOG) from %sBLOG T1 ", qualifier == null ? StringUtils.EMPTY : qualifier);
                if (sqlSuffix != null) {
                    query += sqlSuffix;
                }
                stmt = getConnection().prepareStatement(query);
                rs = stmt.executeQuery();
                rs.next();
                count = rs.getInt(1);
                query = getSQLBaseQuery();
                if (sqlSuffix != null) {
                    query += sqlSuffix;
                }
                stmt = getConnection().prepareStatement(query);
                rs = stmt.executeQuery();
            } catch (final SQLException e) {
                throw new Exception("SELECT_FAILED", e);
            }
        }
        return count;
    }

    private int selectNoCountOptimized(final String sqlSuffix) throws Exception {
        PreparedStatement stmt;
        final int count = -1;
        try {
            String query = getSQLBaseOptimizedQuery();
            if (sqlSuffix != null) {
                query += sqlSuffix;
            }
            if (ctx.getDatas().get("optimizedLimit") != null) {
                query += String.format(" limit 0,%s0", ctx.getDatas().get("optimizedLimit"));
            }
            stmt = getConnection().prepareStatement(query);
            rs = stmt.executeQuery();
        } catch (final SQLException e) {
            throw new Exception("SELECT_FAILED", e);
        }
        return count;
    }

    /**
     * Mise a jour d'une ligne de la base de donnees.
     */
    public void update() throws Exception {
        PreparedStatement stmt = null;
        try {
            stmt = getConnection().prepareStatement("update BLOG set ID_BLOG = ?, TITRE = ?, DESCRIPTION = ?, THEMATIQUE = ?, ARCHIVAGE = ?, CODE = ?, CODE_RUBRIQUE = ?, CODE_RATTACHEMENT = ?, META_KEYWORDS = ?, META_DESCRIPTION = ?, TITRE_ENCADRE = ?, CONTENU_ENCADRE = ?, ENCADRE_RECHERCHE = ?, ENCADRE_RECHERCHE_BIS = ?, DATE_ALERTE = ?, MESSAGE_ALERTE = ?, DATE_CREATION = ?, DATE_PROPOSITION = ?, DATE_VALIDATION = ?, DATE_MODIFICATION = ?, CODE_REDACTEUR = ?, CODE_VALIDATION = ?, LANGUE = ?, ETAT_OBJET = ?, NB_HITS = ?, DIFFUSION_PUBLIC_VISE = ?, DIFFUSION_MODE_RESTRICTION = ?, DIFFUSION_PUBLIC_VISE_RESTRICTION = ? where ID_BLOG = ?");
            stmt.setObject(1, getId(), Types.BIGINT);
            stmt.setObject(2, getTitre(), Types.VARCHAR);
            stmt.setObject(3, getDescription(), Types.LONGVARCHAR);
            stmt.setObject(4, getThematique(), Types.LONGVARCHAR);
            stmt.setObject(5, getArchivage(), Types.VARCHAR);
            stmt.setObject(6, getCode(), Types.VARCHAR);
            stmt.setObject(7, getCodeRubrique(), Types.VARCHAR);
            stmt.setObject(8, getCodeRattachement(), Types.VARCHAR);
            stmt.setObject(9, getMetaKeywords(), Types.LONGVARCHAR);
            stmt.setObject(10, getMetaDescription(), Types.LONGVARCHAR);
            stmt.setObject(11, getTitreEncadre(), Types.VARCHAR);
            stmt.setObject(12, getContenuEncadre(), Types.LONGVARCHAR);
            stmt.setObject(13, getEncadreRecherche(), Types.VARCHAR);
            stmt.setObject(14, getEncadreRechercheBis(), Types.VARCHAR);
            stmt.setObject(15, SqlDateConverter.toDate(getDateAlerte()), Types.DATE);
            stmt.setObject(16, getMessageAlerte(), Types.LONGVARCHAR);
            stmt.setObject(17, SqlDateConverter.toTimestamp(getDateCreation()), Types.TIMESTAMP);
            stmt.setObject(18, SqlDateConverter.toTimestamp(getDateProposition()), Types.TIMESTAMP);
            stmt.setObject(19, SqlDateConverter.toTimestamp(getDateValidation()), Types.TIMESTAMP);
            stmt.setObject(20, SqlDateConverter.toTimestamp(getDateModification()), Types.TIMESTAMP);
            stmt.setObject(21, getCodeRedacteur(), Types.VARCHAR);
            stmt.setObject(22, getCodeValidation(), Types.VARCHAR);
            stmt.setObject(23, getLangue(), Types.VARCHAR);
            stmt.setObject(24, getEtatObjet(), Types.VARCHAR);
            stmt.setObject(25, getNbHits(), Types.BIGINT);
            stmt.setObject(26, getDiffusionPublicVise(), Types.LONGVARCHAR);
            stmt.setObject(27, getDiffusionModeRestriction(), Types.VARCHAR);
            stmt.setObject(28, getDiffusionPublicViseRestriction(), Types.LONGVARCHAR);
            stmt.setObject(29, getId(), Types.BIGINT);
            stmt.executeUpdate();
        } catch (final SQLException e) {
            throw new Exception("ERROR_IN_METHOD update()", e);
        } finally {
            if (stmt != null) {
                stmt.close();
            }
        }
    }
}
